<template>
  <div
    class="min-h-full flex items-center justify-center py-6 px-4 sm:px-6 lg:px-8"
  >
    <div
      class="max-w-lg w-full space-y-2 bg-white p-4 md:px-8 md:py-10 shadow-xl z-index-10"
    >
      <router-link to="/dashboard">
        <span
          class="mb-2 text-white bg-indigo-700 hover:bg-indigo-800 focus:ring-4 focus:ring-indigo-300 font-medium rounded-lg text-sm px-3 py-2 text-center inline-flex items-center  dark:bg-indigo-600 dark:hover:bg-indigo-700 dark:focus:ring-indigo-800"
        >
          Retour
        </span>
      </router-link>

      <div>
        <div class="flex justify-center text-indigo-700">
          <font-awesome-icon icon="gamepad" size="5x" />
        </div>
        <h2 class="mt-6 text-center text-3xl font-extrabold text-gray-900">
          Formulaire - Édition d'un jeu
        </h2>
      </div>

      <Vuemik
        :onSubmit="submitGame"
        v-slot="{ handleSubmit }"
        :initValues="{
          name: this.game.name,
          steam: this.game.urlRedirects.find((obj) => {
                return obj.libelle === 'steam'
              })
            ? this.game.urlRedirects.find((obj) => {
                return obj.libelle === 'steam'
              }).url
            : '',
          epic: this.game.urlRedirects.find((obj) => {
                return obj.libelle === 'epic'
              })
            ? this.game.urlRedirects.find((obj) => {
                return obj.libelle === 'epic'
              }).url
            : '',
          other: this.game.urlRedirects.find((obj) => {
                return obj.libelle === 'autre'
              })
            ? this.game.urlRedirects.find((obj) => {
                return obj.libelle === 'autre'
              }).url
            : ''
        }"
      >
        <div class="mt-8 space-y-6">
          <div class="rounded-md shadow-sm -space-y-px">
            <label class="text-indigo-600">Nom</label>
            <Field component="input" name="name" :class="css.field" />
          </div>
          <div class="rounded-md shadow-sm -space-y-px">
            <label class="text-indigo-600">Lien Steam</label>
            <Field component="input" name="steam" :class="css.field" />
          </div>
          <div class="rounded-md shadow-sm -space-y-px">
            <label class="text-indigo-600">Lien Epic</label>
            <Field component="input" name="epic" :class="css.field" />
          </div>
          <div class="rounded-md shadow-sm -space-y-px">
            <label class="text-indigo-600">Autre Lien</label>
            <Field component="input" name="other" :class="css.field" />
          </div>

          <button
            @click="handleSubmit"
            type="submit"
            class="group relative w-full flex justify-center py-2 px-4 border border-transparent text-sm font-medium rounded-md text-white bg-indigo-500 hover:bg-indigo-600 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-400"
          >
            <span class="absolute left-0 inset-y-0 flex items-center pl-3">
              <font-awesome-icon
                icon="lock"
                :class="`h-5 w-5 text-indigo-400 group-hover:text-indigo-300`"
              />
            </span>
            Soumettre
          </button>
        </div>
      </Vuemik>
    </div>
  </div>
</template>

<script>
import { Vuemik, Field } from "../../lib/Vuemik"

export default {
  name: "EditGame",
  components: {
    Vuemik,
    Field
  },
  data: () => ({
    gameUrl: `https://${window.location.hostname}:8443/games`,
    css: {
      field:
        "pt-4 appearance-none rounded-none relative block w-full px-3 py-2 border border-gray-300 placeholder-gray-500 text-gray-900 rounded-t-md focus:outline-none focus:ring-indigo-500 focus:border-yellow-500 focus:z-10 sm:text-sm"
    },
    game: []
  }),
  inject: ["createAlert", "user"],
  methods: {
    submitGame: function(values) {
      const body = {
        name: values.name,
        studio: "/studios/" + this.user.studio,
        urlRedirects: []
      }

      if (values.steam) {
        body.urlRedirects.push({ libelle: "steam", url: values.steam })
      }

      if (values.epic) {
        body.urlRedirects.push({ libelle: "epic", url: values.epic })
      }

      if (values.other) {
        body.urlRedirects.push({ libelle: "autre", url: values.other })
      }

      const headers = {
        Accept: "application/json",
        "Content-Type": "application/merge-patch+json",
        Authorization: "Bearer " + this.user.token
      }

      fetch(this.gameUrl + "/" + this.$route.params.id, {
        headers,
        method: "PATCH",
        body: JSON.stringify(body)
      })
        .then((res) => {
          if (res.ok) {
            this.$router.push('/dashboard')
            this.createAlert({
            color: "green",
            text: "Modification validé",
            icon: "check"
          })
          } else {
            throw new Error("Something went wrong")
          }
        })
        .catch(() => {
          this.createAlert({
            color: "red",
            text: "Ce jeu n'existe pas",
            icon: "times"
          })
        })
    }
  },
  beforeMount() {
    const headers = {
      Accept: "application/json",
      "Content-Type": "application/json",
      Authorization: "Bearer " + this.user.token
    }

    fetch(this.gameUrl + "/" + this.$route.params.id, {
      headers,
      method: "GET"
    })
      .then((res) => {
        if (res.ok) {
          return res.json()
        } else {
          throw new Error("Something went wrong")
        }
      })
      .then((data) => {
        this.game = data
        console.log(this.game)
      })
      .catch(() => {
        this.$router.push("/404")
        this.createAlert({
          color: "red",
          text: "Ce jeu n'existe pas",
          icon: "times"
        })
      })
  }
}
</script>
